package jp.co.intra_mart.cookbook.im_cookbook_113639.oauth.client.service.processor.impl;

import jp.co.intra_mart.foundation.oauth.client.OAuthClientException;
import jp.co.intra_mart.foundation.oauth.client.model.OAuthConnectionInfo;
import jp.co.intra_mart.foundation.oauth.client.model.OAuthProviderConfigurationFactory;
import jp.co.intra_mart.system.oauth.client.service.AuthzCodeRequest;
import jp.co.intra_mart.system.oauth.client.service.processor.AbstractAuthzCodeRequestProcessor;

/**
 * Google用の OAuth 2.0 認可コードグラントフローで必要な処理を実行するクラスです。<br>
 * Google用に認可コードリクエストを拡張します。
 */
public class GoogleAuthzCodeRequestProcessor extends AbstractAuthzCodeRequestProcessor {

    public GoogleAuthzCodeRequestProcessor() {
        super(GoogleConstants.PROVIDER_TYPE);
    }

    @Override
    protected AuthzCodeRequest createRequestInstance(final String providerId) throws OAuthClientException {
        final OAuthConnectionInfo connectionInfo = OAuthProviderConfigurationFactory.getInstance().getConnectionInfoAccessor().getConnectionInfo(providerId);
        return new GoogleAuthzCodeRequest(providerId, connectionInfo);
    }

}
